<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "communication_log_status_history".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CommunicationLogStatusHistory".
 *
 * Columns in table "communication_log_status_history" available as properties of the model,
 * followed by relations of table "communication_log_status_history" available as properties of the model.
 *
 * @property string $id
 * @property string $communication_log_id
 * @property string $date_added
 * @property string $message_status
 * @property string $status_detail
 * @property string $json_event
 *
 * @property CommunicationLog $communicationLog
 */
abstract class BaseCommunicationLogStatusHistory extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'communication_log_status_history';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CommunicationLogStatusHistory|CommunicationLogStatusHistories', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('communication_log_id, date_added', 'required'),
            array('communication_log_id', 'length', 'max' => 11),
            array('message_status', 'length', 'max' => 50),
            array('status_detail', 'length', 'max' => 255),
            array('json_event', 'safe'),
            array('message_status, status_detail, json_event', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, communication_log_id, date_added, message_status, status_detail, json_event', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'communicationLog' => array(self::BELONGS_TO, 'CommunicationLog', 'communication_log_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'communication_log_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'message_status' => Yii::t('app', 'Message Status'),
            'status_detail' => Yii::t('app', 'Status Detail'),
            'json_event' => Yii::t('app', 'Json Event'),
            'communicationLog' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('communication_log_id', $this->communication_log_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('message_status', $this->message_status, true);
        $criteria->compare('status_detail', $this->status_detail, true);
        $criteria->compare('json_event', $this->json_event, true);

        return new CActiveDataProvider(get_class($this), array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100))
        );
    }

}
